import QtQuick 2.12
import QtQuick.Controls 2.5
import QtQuick.Layouts 1.3

Page {
    width: 1280
    height: 470
    id: receivingForm

    font.capitalization: Font.MixedCase

    Connections {
        target: _qmlHandler
        onReceivingListFile: {
            fileList.append({
                                "fileName": fileName,
                                "fileSize": fileSize + " kb",
                                "fileProgress": "",
                                "fileDecryptable": fileDecryptable,
                                "fileExistsLocally": existsLocally
                            })
        }

        onReceivingClearFileList: {
            fileList.clear()
        }
    }

    ColumnLayout {
        anchors.fill: parent

        ScrollView {
            Layout.preferredWidth: parent.width
            Layout.preferredHeight: 400

            ListView {
                anchors.fill: parent
                model: fileList
                clip: true

                delegate: ReceivingFileTemplate {
                    fileNameText: fileName
                    fileSizeText: fileSize
                    fileProgressText: fileProgress
                    fileDecryptableText: fileDecryptable
                    fileExists: fileExistsLocally
                }
            }
        }

        ListModel {
            id: fileList
        }

        RowLayout {
            Layout.preferredWidth: parent.width
            Layout.preferredHeight: 70

            Button {
                id: receivingListFilesButton
                Layout.preferredWidth: 180
                Layout.preferredHeight: parent.height
                text: qsTr("Refresh File List")

                // @disable-check M223
                onClicked: {
                    // @disable-check M222
                    _qmlHandler.onReceivingListFilesButton()
                }
            }
        }
    }
}



